/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.widget.Form"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Form"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/

dojo.provide("epages.widget.Form");
dojo.require("epages.widget");

dojo.declare("epages.widget.Form", [dijit._Widget], {
		// summary:
		//					widget linked to the <form/> html element
		//					to enhance the functionality of that particular node

	submitButtons: 	[], 		// array of all submit buttons found inside of the form element on startup
									// you can push your dynamically built button in here hence it will be registered
	
	_formName: 		null,
	_elems:			null,
	_submits:		null,
	_invalides:		null,

	_onSubmit: function() {
		for( var i=0,iLength=this.submitButtons.length ; i<iLength ; i++ ) {
			this.submitButtons[i].disabled = true;
		}
	},

	postCreate: function() {
		this.inherited("postCreate", arguments);
		
		this._elems = {};
		this._submits = {};
		this._invalides = {};
		
		//this.submitButtons = dojo.query("[type=submit]", this.domNode);
		
		//this.connect(this.domNode, "submit", "_onSubmit");
		
		// for new formElements Widgets
		this._formName = dojo.attr( this.domNode , 'name' );
		this.connect(this.domNode, 'submit', this.validate);
	},
	
	validate: function(event) {
		var elems = this._elems;
		var error = false;
		
		for( var i in elems ) {
			error = elems[i].validate() ? error : true;
		};
		
		if( error && event ) {
			event.preventDefault();
			console.log('error')
		}
		return !error;
	},
	
	addElem: function( instance ) {
		if( instance.attr('type')=='submit' ) {
			this._submits[instance.id] = instance;
		}
		this._elems[instance.id] = instance;
	},
	
	removeElem: function( id ) {
		if( this._elems[id] ) {
			delete( this._elems[id] );
		}
		if( this._submits[id] ) {
			delete( this._submits[id] );
		}
	},
	
	change: function() {
		var elems = this._elems;
		var error = false;
		for( var i in elems ) {
			error = elems[i].attr('valide') ? error : true;
		}
		
		var elems = this._submits;
		for( var i in elems ) {
			elems[i].attr('disabled',error);
		}
	},
	
	destroy: function() {
		this.inherited('destroy', arguments);
		
		var elems = this._elems;
		
		for( var i in elems ) {
			elems[i].destroy();
		}
	}
})

}
