/*globals define*/

define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!ep/ui/slidebox-test',
    'jquery',

    'ep/ui/slidebox',
    '$ready!'

], function (QUnit, fixture, $, ep) {

    QUnit.module("ep/ui/slidebox", {
        setup: fixture.init,
        teardown: fixture.destroy
    });

    QUnit.asyncTest("ep/ui/slidebox", function () {

        var box = $("#slidebox")
                .uiSlidebox({
                    view: 3,
                    speed: 200,
                    maxWidth: 100
                });

        QUnit.equal(
            box.data('uiUiSlidebox') instanceof $.Widget,
            true,
            "Slide is created and instance of jQuery.Widget"
        );

        QUnit.equal(
            box.find('> ul > li').width(),
            100,
            "Check calculated width of first content box item"
        );

        QUnit.equal(
            box.find('> ul > li:last').width(),
            100,
            "Check calculated width of last content box item"
        );

        box.uiSlidebox('goTo', 0);
        QUnit.equal(
            box.find('> ul > li:first').is(':visible'),
            true,
            "Test functionality to chose a sly by index - first sly is visible"
        );

        box.uiSlidebox('goTo', 'next');
        QUnit.equal(
            box.find('> ul > li').eq(1).is(':visible'),
            true,
            "Test functionality to chose the next sly - second sly is visible"
        );

        box.uiSlidebox('goTo', 'prev');
        QUnit.equal(
            box.find('> ul > li').eq(0).is(':visible'),
            true,
            "Test functionality to chose the previous sly - first sly is visible again"
        );

        box.uiSlidebox('destroy');

        QUnit.equal(
            $(".ep-uislidebox").length,
            0,
            "Slidebox no longer exists after 'destroy'"
        );


        QUnit.start();
    });

});